sk(1)

NAME
sk - sk - fuzzy finder in Rust

SYNOPSIS
sk [--tac] [--no-sort] [-t|--tiebreak] [-n|--nth] [--with-nth] [-d|--delimiter] [-e|--exact] [--regex] [--algo] [--case] [-b|--bind] [-m|--multi] [--no-multi] [--no-mouse] [-c|--cmd] [-i|--interactive] [-I ] [--color] [--no-hscroll] [--keep-right] [--skip-to-pattern] [--no-clear-if-empty] [--no-clear-start] [--no-clear] [--show-cmd-error] [--layout] [--reverse] [--height] [--no-height] [--min-height] [--margin] [-p|--prompt] [--cmd-prompt] [--ansi] [--tabstop] [--inline-info] [--header] [--header-lines] [--history] [--history-size] [--cmd-history] [--cmd-history-size] [--preview] [--preview-window] [-q|--query] [--cmd-query] [--expect] [--read0] [--print0] [--print-query] [--print-cmd] [--print-score] [-1|--select-1] [-0|--exit-0] [--sync] [--pre-select-n] [--pre-select-pat] [--pre-select-items] [--pre-select-file] [-f|--filter] [--tmux] [-h|--help] [-V|--version]

DESCRIPTION
sk - fuzzy finder in Rust

sk is a general purpose command-line fuzzy finder.

ENVIRONMENT VARIABLES

     SKIM_DEFAULT_COMMAND

         Default command to use when input is tty. On *nix systems, sk runs the command with sh -c, so make sure that
         it's POSIX-compliant.

     SKIM_DEFAULT_OPTIONS

         Default options. e.g. export SKIM_DEFAULT_OPTIONS="--multi

 EXTENDED SEARCH MODE

      Unless specified otherwise, sk will start in "extended-search mode". In this mode, you can specify multiple patterns
      delimited by spaces, such as: 'wild ^music .mp3$ sbtrkt !rmx

      You can prepend a backslash to a space (\ ) to match a literal space character.

  Exact-match (quoted)

      A term that is prefixed by a single-quote character (') is interpreted as an "exact-match" (or "non-fuzzy") term. sk
      will search for the exact occurrences of the string.

  Anchored-match

      A term can be prefixed by ^, or suffixed by $ to become an anchored-match term. Then sk will search for the lines
      that start with or end with the given string. An anchored-match term is also an exact-match term.

  Negation

      If a term is prefixed by !, sk will exclude the lines that satisfy the term from the result. In this case, sk per‐
      forms exact match by default.

  Exact-match by default

      If you don't prefer fuzzy matching and do not wish to "quote" (prefixing with ') every word, start sk with -e or
      --exact option. Note that when --exact is set, '-prefix "unquotes" the term.

  OR operator

      A single bar character term acts as an OR operator. For example, the following query matches entries that start with
      core and end with either go, rb, or py.

      e.g. ^core go$ | rb$ | py$

EXIT STATUS
    0 Normal exit
    1 No match
    2 Error
    130 Interrupted with CTRL-C or ESC

OPTIONS

--tac
    Show results in reverse order Often used in combination with --no-sort

--no-sort
    Do not sort the results Often used in combination with --tac Example: `history | sk --tac --no-sort`

-t, --tiebreak=TIEBREAK [default: score,begin,end]
    Comma-separated list of sort criteria to apply when the scores are tied.
        score Score of the fuzzy match algorithm
        index Prefers line that appeared earlier in the input stream
        begin Prefers line with matched substring closer to the beginning
        end Prefers line with matched substring closer to the end
        length Prefers line with shorter length
        - Each criterion could be negated, e.g. (-index)
        - Each criterion should appear only once in the list
    [possible values: score, -score, begin, -begin, end, -end, length, -length]

-n, --nth=NTH [default: ]
    Fields to be matched A field index expression can be a non-zero integer or a range expression ([BEGIN]..[END]). --nth and --with-nth take a comma-separated list of field index expressions. **Examples:**
        1 The 1st field
        2 The 2nd field
        -1 The last field
        -2 The 2nd to last field
        3..5 From the 3rd field to the 5th field
        2.. From the 2nd field to the last field
        ..-3 From the 1st field to the 3rd to the last field
        .. All the fields

--with-nth=WITH_NTH [default: ]
    Fields to be transformed See **nth** for the details

-d, --delimiter=DELIMITER [default: [\t\n ]+]
    Delimiter between fields In regex format, default to AWK-style

-e, --exact
    Run in exact mode

--regex
    Start in regex mode instead of fuzzy-match

--algo=ALGORITHM [default: skim_v2]
    Fuzzy matching algorithm skim_v2 Latest skim algorithm, should be better in almost any case skim_v1 Legacy skim algorithm clangd Used in clangd for keyword completion
    [possible values: skim_v1, skim_v2, clangd]

--case=CASE [default: smart]
    Case sensitivity Determines whether or not to ignore case while matching
    [possible values: respect, ignore, smart]

-b, --bind=BIND
    Comma separated list of bindings You can customize key bindings of sk with --bind option which takes a comma-separated list of key binding expressions. Each key binding expression follows the following format: KEY:ACTION e.g. sk --bind=ctrl-j:accept,ctrl-k:kill-line AVAILABLE KEYS: (SYNONYMS)
        ctrl-[a-z]
        ctrl-space
        ctrl-alt-[a-z]
        alt-[a-zA-Z]
        alt-[0-9]
        f[1-12]
        enter (ctrl-m)
        space
        bspace (bs)
        alt-up
        alt-down
        alt-left
        alt-right
        alt-enter (alt-ctrl-m)
        alt-space
        alt-bspace (alt-bs)
        alt-/
        tab
        btab (shift-tab)
        esc
        del
        up
        down
        left
        right
        home
        end
        pgup (page-up)
        pgdn (page-down)
        shift-up
        shift-down
        shift-left
        shift-right
        alt-shift-up
        alt-shift-down
        alt-shift-left
        alt-shift-right
        or any single character
      ACTION: DEFAULT BINDINGS (NOTES):
        abort ctrl-c ctrl-q esc
        accept enter
        append-and-select
        backward-char ctrl-b left
        backward-delete-char ctrl-h bspace
        backward-kill-word alt-bs
        backward-word alt-b shift-left
        beginning-of-line ctrl-a home
        clear-screen ctrl-l
        delete-char del
        delete-charEOF ctrl-d
        deselect-all
        down ctrl-j ctrl-n down
        end-of-line ctrl-e end
        execute(...) (see below for the details)
        execute-silent(...) (see below for the details)
        forward-char ctrl-f right
        forward-word alt-f shift-right
        if-non-matched
        if-query-empty
        if-query-not-empty
        ignore
        kill-line
        kill-word alt-d
        next-history (ctrl-n on --history or --cmd-history)
        page-down pgdn
        page-up pgup
        half-page-down
        half-page-up
        preview-up shift-up
        preview-down shift-down
        preview-left
        preview-right
        preview-page-down
        preview-page-up
        previous-history (ctrl-p on --history or --cmd-history)
        reload(...)
        select-all
        toggle
        toggle-all
        toggle+down ctrl-i (tab)
        toggle-in (--layout=reverse* ? toggle+up : toggle+down)
        toggle-out (--layout=reverse* ? toggle+down : toggle+up)
        toggle-preview
        toggle-preview-wrap
        toggle-sort
        toggle+up btab (shift-tab)
        unix-line-discard ctrl-u
        unix-word-rubout ctrl-w
        up ctrl-k ctrl-p up
        yank ctrl-y Multiple actions can be chained using + separator.
        sk --bind 'ctrl-a:select-all+accept' With execute(...) and reload(...) action, you can execute arbitrary commands without leaving sk. For example, you can turn sk into a simple file browser by binding enter key to less command like follows.
        sk --bind "enter:execute(less {})" Note: if no argument is supplied to reload, the default command is run. You can use the same placeholder expressions as in --preview. If the command contains parentheses, sk may fail to parse the expression. In that case, you can use any of the following alternative notations to avoid parse errors.
        execute[...]
        execute'...'
        execute"..."
        execute:...
           This is the special form that frees you from parse errors as it does not expect the clos‐
           ing character. The catch is that it should be the last one in the comma-separated list of
           key-action pairs. sk switches to the alternate screen when executing a command. However, if the command is ex‐ pected to complete quickly, and you are not interested in its output, you might want to use exe‐ cute-silent instead, which silently executes the command without the switching. Note that sk will not be responsive until the command is complete. For asynchronous execution, start your command as a background process (i.e. appending &). With if-query-empty and if-query-not-empty action, you could specify the action to execute de‐ pends on the query condition. For example
        sk --bind 'ctrl-d:if-query-empty(abort)+delete-char' If the query is empty, skim will execute abort action, otherwise execute delete-char action. It is equal to ‘delete-char/eof‘.

-m, --multi
    Enable multiple selection Uses Tab and S-Tab by default for selection

--no-multi
    Disable multiple selection

--no-mouse
    Disable mouse

-c, --cmd=CMD
    Command to invoke dynamically in interactive mode Will be invoked using `sh -c`

-i, --interactive
    Run in interactive mode

-I=REPLSTR [default: {}]
    Replace replstr with the selected item in commands

--color=COLOR
    Set color theme Format: [BASE][,COLOR:ANSI]

--no-hscroll
    Disable horizontal scroll

--keep-right
    Keep the right end of the line visible on overflow Effective only when the query string is empty

--skip-to-pattern=SKIP_TO_PATTERN
    Show the matched pattern at the line start Line will start with the start of the matched pattern. Effective only when the query string is empty. Was designed to skip showing starts of paths of rg/grep results. e.g. sk -i -c "rg {} --color=always" --skip-to-pattern '[^/]*:' --ansi

--no-clear-if-empty
    Do not clear previous line if the command returns an empty result Do not clear previous items if new command returns empty result. This might be useful to reduce flickering when typing new commands and the half-complete commands are not valid. This is not default however because similar usecases for grep and rg had already been op‐ timized where empty result of a query do mean "empty" and previous results should be cleared.

--no-clear-start
    Do not clear items on start

--no-clear
    Do not clear screen on exit Do not clear finder interface on exit. If skim was started in full screen mode, it will not switch back to the original screen, so you'll have to manually run tput rmcup to return. This option can be used to avoid flickering of the screen when your application needs to start skim multiple times in order.

--show-cmd-error
    Show error message if command fails

--layout=LAYOUT [default: default]
    Set layout default Display from the bottom of the screen reverse Display from the top of the screen reverse-list Display from the top of the screen, prompt at the bottom
    [possible values: default, reverse, reverse-list]

--reverse
    Shorthand for reverse layout

--height=HEIGHT [default: 100%]
    Height of skim's window Can either be a row count or a percentage

--no-height
    Disable height feature

--min-height=MIN_HEIGHT [default: 10]
    Minimum height of skim's window Useful when the height is set as a percentage Ignored when --height is not specified

--margin=MARGIN [default: 0]
    Screen margin For each side, can be either a row count or a percentage of the terminal size Format can be one of:
        - TRBL
        - TB,RL
        - T,RL,B
        - T,R,B,L Example: 1,10%

-p, --prompt=PROMPT [default: > ]
    Set prompt

--cmd-prompt=CMD_PROMPT [default: c> ]
    Set prompt in command mode

--ansi
    Parse ANSI color codes in input strings

--tabstop=TABSTOP [default: 8]
    Number of spaces that make up a tab

--inline-info
    Display info next to the query

--header=HEADER
    Set header, displayed next to the info The given string will be printed as the sticky header. The lines are displayed in the given order from top to bottom regardless of --layout option, and are not affected by --with-nth. ANSI color codes are processed even when --ansi is not set.

--header-lines=HEADER_LINES [default: 0]
    Number of lines of the input treated as header The first N lines of the input are treated as the sticky header. When --with-nth is set, the lines are transformed just like the other lines that follow.

--history=HISTORY
    History file Load search history from the specified file and update the file on completion. When enabled, CTRL-N and CTRL-P are automatically remapped to next-history and previous-history.

--history-size=HISTORY_SIZE [default: 1000]
    Maximum number of query history entries to keep

--cmd-history=CMD_HISTORY
    Command history file Load command query history from the specified file and update the file on completion. When enabled, CTRL-N and CTRL-P are automatically remapped to next-history and previous-history.

--cmd-history-size=CMD_HISTORY_SIZE [default: 1000]
    Maximum number of query history entries to keep

--preview=PREVIEW
    Preview command Execute the given command for the current line and display the result on the preview window. {} in the command is the placeholder that is replaced to the single-quoted string of the current line. To transform the replace‐ ment string, specify field index expressions between the braces (See FIELD INDEX EXPRESSION for the details). e.g. sk --preview='head -$LINES {}'
         ls -l | sk --preview="echo user={3} when={-4..-2}; cat {-1}" --header-lines=1 sk overrides $LINES and $COLUMNS so that they represent the exact size of the preview window. A placeholder expression starting with + flag will be replaced to the space-separated list of the selected lines (or the current line if no selection was made) individually quoted. e.g.
         sk --multi --preview='head -10 {+}'
         git log --oneline | sk --multi --preview 'git show {+1}' Note that you can escape a placeholder pattern by prepending a backslash. Also, {q} is replaced to the current query string. {cq} is replaced to the current command query string. {n} is replaced to zero-based ordinal index of the line. Use {+n} if you want all index numbers when multiple lines are selected Preview window will be updated even when there is no match for the current query if any of the placeholder ex‐ pressions evaluates to a non-empty string.

--preview-window=PREVIEW_WINDOW [default: right:50%]
    Preview window layout Format: [up|down|left|right][:SIZE[%]][:hidden][:+SCROLL[-OFFSET]] Determine the layout of the preview window. If the argument ends with :hidden, the preview window will be hidden by default until toggle-preview action is triggered. Long lines are truncated by default. Line wrap can be enabled with :wrap flag. If size is given as 0, preview window will not be visible, but sk will still execute the command in the background. +SCROLL[-OFFSET] determines the initial scroll offset of the preview window. SCROLL can be either a numeric integer or a single-field index expression that refers to a numeric integer. The optional -OFFSET part is for adjusting the base offset so that you can see the text above it. It should be given as a numeric integer (-INTEGER), or as a denom‐ inator form (-/INTEGER) for specifying a fraction of the preview window height. e.g. # Non-default scroll window positions and sizes sk --preview="head {}" --preview-window=up:30% sk --preview="file {}" --preview-window=down:2 # Initial scroll offset is set to the line number of each line of # git grep output *minus* 5 lines (-5) git grep --line-number '' | sk --delimiter : --preview 'nl {1}' --preview-window +{2}-5 # Preview with bat, matching line in the middle of the window (-/2) git grep --line-number '' | sk --delimiter : \ --preview 'bat --style=numbers --color=always --highlight-line {2} {1}' \ --preview-window +{2}-/2

-q, --query=QUERY
    Initial query

--cmd-query=CMD_QUERY
    Initial query in interactive mode

--expect=EXPECT
    Comma separated list of keys used to complete skim Comma-separated list of keys that can be used to complete sk in addition to the default enter key. When this option is set, sk will print the name of the key pressed as the first line of its output (or as the second line if --print-query is also used). The line will be empty if sk is completed with the default enter key. If --expect option is specified multiple times, sk will expect the union of the keys. --no-expect will clear the list. e.g. sk --expect=ctrl-v,ctrl-t,alt-s --expect=f1,f2,~,@

--read0
    Read input delimited by ASCII NUL(\\0) characters

--print0
    Print output delimited by ASCII NUL(\\0) characters

--print-query
    Print the query as the first line

--print-cmd
    Print the command as the first line (after print-query)

--print-score
    Print the command as the first line (after print-cmd)

-1, --select-1
    Automatically select the match if there is only one

-0, --exit-0
    Automatically exit when no match is left

--sync
    Synchronous search for multi-staged filtering Synchronous search for multi-staged filtering. If specified, skim will launch ncurses finder only after the input stream is complete. e.g. sk --multi | sk --sync

--pre-select-n=PRE_SELECT_N [default: 0]
    Pre-select the first n items in multi-selection mode

--pre-select-pat=PRE_SELECT_PAT [default: ]
    Pre-select the matched items in multi-selection mode Check the doc for the detailed syntax: https://docs.rs/regex/1.4.1/regex/

--pre-select-items=PRE_SELECT_ITEMS [default: ]
    Pre-select the items separated by newline character Exemple: 'item1\nitem2'

--pre-select-file=PRE_SELECT_FILE
    Pre-select the items read from this file

-f, --filter=FILTER
    Query for filter mode

--tmux=TMUX
    Reserved for later use Run in a tmux popup Format: sk --tmux <center|top|bottom|left|right>[,SIZE[%]][,SIZE[%]] Depending on the direction, the order and behavior of the sizes varies:
        - center: (width, height) or (size, size) if only one is provided
        - top | bottom: (height, width) or height = size, width = 100% if only one is provided
        - left | right: (width, height) or height = 100%, width = size if only one is provided Default: center,50%

-h, --help
    Print help (see a summary with '-h')

-V, --version
    Print version

VERSION
v0.13.0